##########################################################################
# Compability section: obsolete/superceded functions are defined here

PrintDynkinDiagram:=function(arg)
  InfoChevie("#W PrintDynkinDiagram is obsolete; use PrintDiagram\n");
  ApplyFunc(PrintDiagram,arg);
end;

CartanType:=function(arg)
  InfoChevie("#W CartanType is obsolete; use ReflectionType\n");
  return ApplyFunc(ReflectionType,arg);
end;

CartanName:=function(arg)
  InfoChevie("#W CartanName is obsolete; use ReflectionName\n");
  return ApplyFunc(ReflectionName,arg);
end;

PermBraid:=function(arg)
  InfoChevie("#W PermBraid is obsolete; use EltBraid\n");
  return ApplyFunc(EltBraid,arg);
end;

WordBraid:=function(arg)
  InfoChevie("#W WordBraid is obsolete; use AsWord\n");
  return ApplyFunc(AsWord,arg);
end;

BraidWords:=function(W,l)
  InfoChevie("#W BraidWords is obsolete; use GarsideWords(BraidMonoid(W),l)\n");
  return GarsideWords(BraidMonoid(W),l);
end;

CoxeterElementsLength:=function(arg)
  InfoChevie("#W CoxeterElementsLength is obsolete; use CoxeterElements\n");
  return ApplyFunc(CoxeterElements,arg);
end;

PermCoxeterWord:=function(arg)
  InfoChevie("#W PermCoxeterWord is obsolete; use EltWord\n");
  return ApplyFunc(EltWord,arg);
end;

DirectSumCartanMat:=function(arg)
  InfoChevie("#W DirectSumCartanMat is obsolete; use DiagonalMat\n");
  return ApplyFunc(DiagonalMat,arg);
end;

Weyl:=function(arg)
  InfoChevie("#W Weyl is obsolete; use CoxeterGroup\n");
  return ApplyFunc(CoxeterGroup,arg);
end;

PermWeylWord:=function(arg)
  InfoChevie("#W PermWeylWord is obsolete; use PermCoxeterWord\n");
  return ApplyFunc(PermCoxeterWord,arg);
end;

WeylWordPerm:=function(arg)
  InfoChevie("#W WeylWordPerm is obsolete; use CoxeterWord\n");
  return ApplyFunc(CoxeterWord,arg);
end;

WeylLengthPerm:=function(arg)
  InfoChevie("#W WeylLengthPerm is obsolete; use CoxeterLength\n");
  return ApplyFunc(CoxeterLength,arg);
end;

ReducedWeylWord:=function(arg)
  InfoChevie("#W ReducedWeylWord is obsolete; use ReducedCoxeterWord\n");
  return ApplyFunc(ReducedCoxeterWord,arg);
end;

LongestWeylWord:=function(arg)
  InfoChevie("#W LongestWeylWord is obsolete; use LongestCoxeterWord\n");
  return ApplyFunc(LongestCoxeterWord,arg);
end;

ReducedInCoxeterCoset:=function(arg)
  InfoChevie("#W ReducedInCoxeterCoset is obsolete; use ReducedInRightCoset\n");
  return ApplyFunc(ReducedInRightCoset,arg);
end;

WeylElements:=function(arg)
  InfoChevie("#W WeylElements is obsolete; use CoxeterWords\n");
  return ApplyFunc(CoxeterWords,arg);
end;

WeylConjugacyClasses:=function(arg)
  InfoChevie("#W WeylConjugacyClasses is obsolete; use WordsClassRepresentatives\n");
  return ApplyFunc(WordsClassRepresentatives,arg);
end;

CoxeterConjugacyClasses:=function(arg)
  InfoChevie("#W CoxeterConjugacyClasses is obsolete; use WordsClassRepresentatives\n");
  return ApplyFunc(WordsClassRepresentatives,arg);
end;

WeylMueMat:=function(arg)
  InfoChevie("#W WeylMueMat is obsolete; use KLMueMat\n");
  return ApplyFunc(KLMueMat,arg);
end;

KLCoefficient:=function(arg)
  InfoChevie("#W KLCoefficient is obsolete; use KazhdanLusztigCoefficient\n");
  return ApplyFunc(KazhdanLusztigCoefficient,arg);
end;

CharHeckeRepresentation:=function(arg)
  InfoChevie("#W CharHeckeRepresentation is obsolete; use CharRepresentationWords\n");
  return ApplyFunc(CharRepresentationWords,arg);
end;

DoublePartitionToString:=function(arg)
  InfoChevie("#W DoublePartitionToString is obsolete; use PartitionTupleToString\n");
  return ApplyFunc(PartitionTupleToString,arg);
end;

SimpleReflexionMatrices:=function(mat)
  InfoChevie("#W SimpleReflectionMatrices(C) is obsolete; use CoxeterGroup(C).matgens\n");
  return CoxeterGroup(mat).matgens;
end;

Rootsystem:=function(mat)
  InfoChevie("#W RootSystem(C) is obsolete; use CoxeterGroup(C).roots\n");
  return CoxeterGroup(mat).roots;
end;

PermRepresentationRoots:=function(mats,roots)
  return List(roots*mats,SortingPerm)/SortingPerm(roots);
end;

WeylReflections:=W->List(Reflections(W),x->CoxeterWord(W,x));

CoxeterWordReflections:=WeylReflections;

DoublePartitions:=function(n)
  InfoChevie("#W DoublePartitions(n) is obsolete; use PartitionTuples(n,2)\n");
  return PartitionTuples(n,2);
end;

WeylRightCosetRepresentatives:=function(W,I,J)
    return List(ReducedRightCosetRepresentatives(
                   ReflectionSubgroup(W,W.rootInclusion{I}),
                   ReflectionSubgroup(W,W.rootInclusion{J})),
                   x->CoxeterWord(W,x));
end;

WeylCosetPermRepresentation:=function(W,I)
  return PermCosetsSubgroup(W,ReflectionSubgroup(W,W.rootInclusion{I})); 
end;

WeylClassPolynomials:=function(arg)
  Error("#W does not exist any more, use 'HeckeClassPolynomials'\n");
end;

HeckeCharTable:=function(arg)
 Error("#W does not exist any more, use CharTable(Hecke(CoxeterGroup(...)))\n");
end;

HeckeFusion:=function(arg)
  Print("#W does not exist any more, use Specialization and InductionTable\n");
end;

HeckePowermap:=function(arg)
 Error("#W does not exist any more, use Specialization and Character tables\n");
end;

HeckeCharTableDirectProduct:=function(arg)
 Error("#W does not exist any more, use CharTable(Hecke(CoxeterGroup(...)))\n");
end;

HeckeScalarProducts:=function(arg)
  Error("#W does not exist any more, use Specialization and CharTable(Hecke(CoxeterGroup(...)))\n");
end;

HeckeReducedChar:=function(arg)
  Error("#W does not exist any more, use Specialization and CharTable(Hecke(CoxeterGroup(...)))\n");
end;

#########################################################################
#F  ParametersCentralizers(  <W> )  .  .  parameters for  the  conjugacy
##  classes of  centralizers of semisimple elements in a Chevalley group.
##
##  The  function  returns  a  list  of  pairs  which  parameterize  the
##  conjugacy classes.  The pairs are representatives  under W-conjugacy
##  of pairs of a subset I of the extended basis of the root system of W
##  (the fundamental roots union the  opposite of the highest root), and
##  an element of the stabilizer in W of I.
##
ParametersCentralizers := function(W)local closure,t,cp,o,orb,res,x,symm,inv;
  symm:=l->Union(l,List(l,function(i)if i>W.N then return i-W.N;
                                              else return i+W.N;fi;end));
  closure:=function(W,l)local i,j,n,p; # closure of a set of roots
    n:=ShallowCopy(l);
    for i in n do
      for j in n do
	p:=Position(W.roots,W.roots[i]+W.roots[j]);
	if p<>false and not p in n then Add(n, p); fi;
      od;
    od;
    Sort(n);
    return n;
  end;
# inv:=x->Collected(W.orbitRepresentative{x});
  inv:=x->IsomorphismType(ReflectionSubgroup(W,x));
  t:=[1..W.semisimpleRank];Add(t,2*W.N);
  t:=Filtered(Combinations(t),x->Length(x)<=W.semisimpleRank);
# t:=List(Orbits(W,t,OnSets),x->x[1]); # Orbits is too slow, do it by hand
  o:=Set(List(t,inv));
  orb:=List(o,x->[]);for x in t do Add(orb[Position(o,inv(x))],x);od;
  t:=[];
  for o in orb do
    res:=[o[1]];
    for x in o{[2..Length(o)]} do
      if not ForAny(res,i->RepresentativeOperation(W,i,x,OnSets)<>false) then
        Add(res,x);
      fi;
    od;
    Append(t,res);
  od;
# end of Orbits done by hand
  SortParallel(List(t,i->closure(W,symm(i))),t,
      function(i,j)return IsSubset(j,i);end);
  InfoChevie( "#I  Number of Psi's = ",Length(t),"\c");
  cp:=List(t,i->List(ConjugacyClasses(Stabilizer(W,i,OnSets)),
                            c->[i,CoxeterWord(W,Representative(c))]));
  InfoChevie("\n#I  ",List(cp,Length)," conjugacy classes ");
  cp:=Concatenation(cp);
  InfoChevie("\n","#I  Number of Pairs = ",Length(cp),"\n" );
  return cp;
end;
