# determinant of a matrix of Polynomials(Rationals)
PolynomialDet:=function(m)local n,v,i,j,k,M,l,d,dircoeff,dnorm,norm,coeff;
  n:=Length(m);
  if Length(m)=1 then return m[1][1];
  elif Length(m)=2 then return m[1][1]*m[2][2]-m[1][2]*m[2][1];
  fi;
  dircoeff:=function(p)
    if Length(p.coefficients)=0 then return 0;fi;
    return p.coefficients[Length(p.coefficients)];
  end;
  dnorm:=function(p)if Length(p.coefficients)=0 then return 1;fi;
    return Lcm(List(p.coefficients,Denominator));
  end;
  norm:=function(p)if Length(p.coefficients)=0 then return 0;fi;
    return Gcd(p.coefficients);
  end;
  m:=ShallowCopy(m);
  coeff:=1;
  repeat
    l:=List(m,function(x)local d;
      d:=Lcm(List(x,dnorm));return d/Gcd(List(x*d,norm));
    end);
    coeff:=coeff/Product(l);
#   Print("coeff=",coeff,"\n");
    for i in [1..n] do m[i]:=m[i]*l[i];od;
    M:=Maximum(List(m,x->Maximum(List(x,y->Length(y.coefficients)))));
    M:=List(m,x->MinPos(List(x,function(y)local l;l:=Length(y.coefficients);
      if l=0 then return [M+1,0,0];fi;
      return [l,AbsInt(y.valuation),
        Length(String(Maximum(List(y.coefficients*dnorm(y),AbsInt))))];
    end)));
    i:=MinPos(List(M,x->x[1]))[2];M:=M[i];j:=M[2];M:=M[1];
    v:=dircoeff(m[i][j]);
    for k in Filtered([1..n],j->j<>i) do
      l:=dircoeff(m[k][j])/v;
      if l<>0 then
	if M[1]=1 then m[k]:=m[k]-EuclideanQuotient(m[k][j],m[i][j])*m[i];
	else d:=Degree(m[k][j])-Degree(m[i][j]);
	     m[k]:=m[k]-List(m[i],function(p)
		p:=ShallowCopy(p);
		p.coefficients:=p.coefficients*l;
		p.valuation:=p.valuation+d;
		return p;
		end);
	fi;
      fi;
    od;
    Print(Length(m),":",M," \c");
  until M[1]=1;
  return coeff*(-1)^(i+j)*m[i][j]*PolynomialDet(
    m{Concatenation([1..i-1],[i+1..n])}{Concatenation([1..j-1],[j+1..n])});
end;
